EvaluateSystemScript("time.js");

FALLING=0;   //These are the 'constants' for the state (_state)
STANDING=1;  //Terrance is in. The numbers are arbitrary and
JUMPING=2;   //simply set the 'constants' apart from eachother.
SWIMMING=3;
FLYING=4;

frame = 0;     //This is the current frame of animation for Terrance.
frame_max = 4;  //This is how many frames Terrance has. (A count, not an index)

jump_length = 100; //This is how many frames a single jump will last at maximum.
jump_frame = 0; //This is the current jump frame.

//This is the jump speed. It is considered an envionment variable.
//I have made it point to a function so that exponential values
//are easier.

enemy1 = new ground_enemy("enemy1", 1806, 1968);

function _jump(){
  return(30*(1-jump_frame/jump_length)+1);
} 

function initiate_engine(){

  BindKey(KEY_UP, "", "");     //Clear the keys so I can define what they do.
  BindKey(KEY_RIGHT, "", "");
  BindKey(KEY_DOWN, "", "");
  BindKey(KEY_LEFT, "", "");

  if(_state==undefined) _state = FALLING;
  CreatePerson("Terrance", "terrance.rss", true);
  AttachInput("Terrance");
  AttachCamera("Terrance");
  SetPersonDirection("Terrance", "east");
  won=false;
  lost=false;
  while(won==false && lost==false){ 
      if(IsKeyPressed(KEY_RIGHT)){ //Terrance will move right if the right key is pressed.
        SetPersonDirection("Terrance", "east");
        setCharX(charX()+_speed);            //Terrence will move by _speed in pixels.
        if(AreKeysLeft()) GetKey();      
      }
      if(IsKeyPressed(KEY_LEFT)){ //Terrence will move left if the left key is pressed.
        SetPersonDirection("Terrance", "west");
        setCharX(charX()-_speed);
        if(AreKeysLeft()) GetKey();     
      }
      if(!IsKeyPressed(KEY_LEFT) && !IsKeyPressed(KEY_RIGHT) && !IsKeyPressed(KEY_SPACE))
         SetPersonFrame("Terrance", 0);
      if(IsKeyPressed(KEY_SPACE)){ //Terrence will start jumping if the space bar is pressed.
        if(_state==STANDING){
          _state=JUMPING;
          jump_frame=0;
        }
        if(AreKeysLeft()) GetKey();
      }
      else{
        if(_state==JUMPING)
          _state=FALLING;
      }

    //This will check on Terrance's _state and do what it tells the engine to do :)
    switch(_state){
      case FALLING: 
        setCharY(charY()+_gravity); 
        if(IsPersonObstructed("Terrance", charX(), charY()-1)){  //If Terrance is obstructed on the pixel beneath him,
          _state=STANDING;                                      //make him land and stop falling by making him STANDING.
          for(i=charY(); IsPersonObstructed("Terrance", charX(), i); i--)
            setCharY(i-1);
        }
        //else
          //Make Tarrance fall. _gravity is in pixels per frame.
        break;
      case JUMPING:
        if(jump_frame< (jump_length+_jump()) ) setCharY(charY()-_jump());
        else _state = FALLING;
        jump_frame+=_jump();
        SetPersonFrame("Terrance", 0);
        break;
      case STANDING:
        _state=FALLING;
    }
    RenderScreen();
    FlipScreen();
    Delay(1000/60);
    if(charY()>fall_point) lost=true;
    enemy1.update();
  }   
}
    
      
//The following 6 functions were made because I didn't want to have to type
//the same stuff over and over and over again. Just convenience.

function charX(){
  return(GetPersonX("Terrance"));
}

function charY(){
  return(GetPersonY("Terrance"));
}

function setCharX(x){
  if(charX()<x){ while(charX()<x && !IsPersonObstructed("Terrance", charX()+1, charY())){ QueuePersonCommand("Terrance", COMMAND_MOVE_EAST, true); UpdateMapEngine(); }}
  else         { while(charX()>x && !IsPersonObstructed("Terrance", charX()-1, charY())){ QueuePersonCommand("Terrance", COMMAND_MOVE_WEST, true); UpdateMapEngine(); }} 
}

function setCharY(y){
  SetPersonY("Terrance", y);
}

function checkKey(){
  if(AreKeysLeft())
    return(GetKey());
  else
    return(false);
}

function RenderScreen(){
  UpdateMapEngine();
  RenderMap();
}

function ground_enemy(person, range1, range2){
  this.speed=5;
  this.range1=range1;
  this.range2=range2;
  this.person=person;
  this.direction = -1;
  this.center = GetPersonX(person);
  this.dieframe = 0;
  this.coins = 5;
}

ground_enemy.prototype.update = function(){
  for(i=0; i<this.speed; i++){
    switch(this.direction){
      case -1: QueuePersonCommand(this.person, COMMAND_MOVE_WEST, true); break;
      case  1: QueuePersonCommand(this.person, COMMAND_MOVE_EAST, true); break;
    }
  }
  for(i=0; !IsPersonObstructed(this.person, GetPersonX(this.person), GetPersonY(this.person)+1); i++){
    QueuePersonCommand(this.person, COMMAND_MOVE_SOUTH, true);
    UpdateMapEngine();
  }
  if(this.direction==-1) QueuePersonCommand(this.person, COMMAND_FACE_WEST, true);
  else QueuePersonCommand(this.person, COMMAND_FACE_EAST, true);
  if(GetPersonX(this.person)>=this.range2){
    this.direction=-1;
  }
  if(GetPersonX(this.person)<=this.range1){
    this.direction=1;
  }
}

ground_enemy.prototype.die = function(){
  switch(this.direction){
    case -1: direction = 5; break;
    case  1: direction = 3; break;
  }
  this.direction = 0;
  SetPersonDirection(this.person, direction);
  if(this.dieframe<4) SetPersonFrame(this.dieframe);
  else{
    Coins+=this.coins;
    DestroyPerson(this.person);
  }
  if(this.dieframe<4) this.dieframe++;
}

ground_enemy.prototype.hit = function(){
  if(charY()<GetPersonY(this.person))
    this.die();
}
  
  