/* 
// Catgirl Pong!
// Darklich aka Jacky Chong
// last updated: 30th June 2001
*/

var system_font = GetSystemFont();
var screen_width = 320;
var screen_height = 240;
var logic_time = 20;
var logic_limit = 2;

function game()
{
  f_x = Math.floor(Math.random() * 150) + 100;
  f_y = Math.floor(Math.random() * 100) + 100;
  pinky = new catgirl(2, 0, false, "blah");
  minky = new catgirl(318, 0, true, "blah");
  ball = new furball(f_x, f_y, pinky, minky);
  
  // I cheat since I'm bad at winning ;)
  pinky.height = 30;
  
  var pink = CreateColor(237, 108, 158);
  var green = CreateColor(0, 176, 52);
  var black = CreateColor(0, 0, 0);
  var white = CreateColor(255, 255, 255);
  var done = false;
  var game_time = GetTime() + logic_time;
  var limit = logic_limit;
  var stop = false;

  //SetFrameRate(100);
  while (!done)
  {
    pinky.update();
    minky.update();
    GradientLine(ball.x, ball.y, ball.trail_x, ball.trail_y, black, white);
    Line(pinky.draw_x, pinky.draw_y, pinky.draw_x, pinky.draw_y + pinky.height, pink);
    Line(minky.draw_x, minky.draw_y, minky.draw_x, minky.draw_y + minky.height, green);

    if (limit-- > 0 && game_time > GetTime()) {
      //DrawText(0, 0, "Logic Used");
      stop = ball.update();
      FlipScreen();
    } else {
      if (game_time < GetTime()) {
        //DrawText(0, 0, "Logic Off");
        limit = logic_limit;
        game_time += logic_time;
      }
    }

    //stop = ball.update();
    if (stop)
    {
      // reset and say who won!
      var text;
      var text_length;
      
      if (ball.x < 0)
        text = "minky won!";
      else
        text = "pinky won!";
        
      text_length = system_font.getStringWidth(text);
      DrawText((screen_width - text_length) / 2, 110, text);
      FlipScreen();
      
      pause();
      pinky.reset();
      minky.reset();
      if (ball.x < 0)
        ball.x = minky.x + 1;
      else
        ball.x = pinky.x + 1;

      ball.y = pinky.y + (pinky.height / 2);
      ball.update();
      stop = false;
    }

    //DrawText(0, 10, minky.ai_wait);
    //DrawText(0, 10, game_time);
    //DrawText(0, 20, GetTime());
    //FlipScreen();
    
    while (AreKeysLeft())
      switch (GetKey())
      {
        case KEY_ESCAPE: done = true; break;
        case KEY_UP: pinky.y -= 5; break;
        case KEY_DOWN: pinky.y += 5; break;
      }
  }
}

function furball(x, y, catgirl_left, catgirl_right)
{
  this.x = x;
  this.y = y;
  this.momentum_x = 1;
  this.momentum_y = 1;
  this.catgirl_left = catgirl_left;
  this.catgirl_right = catgirl_right;
  
  this.trail_x = this.x;
  this.trail_y = this.y;
}

furball.prototype.update = function()
{
  // furball logic!
  this.x += this.momentum_x;
  this.y += this.momentum_y;
  
  if (this.momentum_x > 0)
    this.trail_x = this.x - 10;
  else
    this.trail_x = this.x + 10;
  if (this.momentum_y > 0)
    this.trail_y = this.y - 10;
  else
    this.trail_y = this.y + 10;
/*  
  // when the furball hits the left wall...
  if (this.x < 0) 
  {
    this.x = 0;
    this.momentum_x = 1;
  }
  
  // when the furball hits the right wall...
  if (this.x > screen_width - 1)
  {
    this.x = screen_width - 1;
    this.momentum_x = -1;
  }
*/
  if (this.x < 0 || this.x > screen_width - 1)
    return true;
  
  // when the furball hits the top wall...
  if (this.y < 0) 
  {
    this.y = 0;
    this.momentum_y = 1;
  }
  
  // when the furball hits the bottom wall...
  if (this.y > screen_height - 1)
  {
    this.y = screen_height - 1;
    this.momentum_y = -1;
  }
 
  // if the furball hits the left catgirl
  if (this.x == this.catgirl_left.x && 
      this.y >= this.catgirl_left.y &&
      this.y <= this.catgirl_left.y + this.catgirl_left.height)
  {
    this.x = this.catgirl_left.x + 1;
    this.momentum_x = 1;
  }
  
  // AI logic
  if (this.catgirl_right.ai == true && this.momentum_x > 0) 
  {
    this.catgirl_right.update_ai(this.y);
  }
  if (this.catgirl_left.ai == true && this.momentum_x < 0)
  {
    this.catgirl_left.update_ai(this.y);
  }
  
  // if the furball hits the right catgirl
  if (this.x == this.catgirl_right.x && 
      this.y >= this.catgirl_right.y &&
      this.y <= this.catgirl_right.y + this.catgirl_right.height)
  {
    this.x = this.catgirl_right.x - 1;
    this.momentum_x = -1;
  }
  
  return false;
}

function catgirl(x, y, ai, image)
{
  this.x = x;
  this.y = x;
  this.draw_x = x;
  this.draw_y = y;
  this.width = 1;
  this.height = 20;
  this.ai = ai;
  this.ai_wait_max = 5;
  this.ai_wait = Math.floor(Math.random() * this.ai_wait_max);
  this.image = undefined;
}

catgirl.prototype.reset = function()
{
  this.y = (screen_height - this.height) / 2;
  this.draw_y = this.y;
  this.ai_wait = Math.floor(Math.random() * this.ai_wait_max);
}

catgirl.prototype.update_ai = function(y)
{
  if (this.ai_wait-- > 0)
    return;

  this.ai_wait = Math.floor(Math.random() * this.ai_wait_max);
  if (y < this.y)
  { 
    this.y -= 5;
  } 
  else if (y > this.y + this.height)
  {
    this.y += 5;
  }
}

catgirl.prototype.update = function()
{
/*
  if (!this.ai)
  {
    this.draw_y = this.y;
    return;
  }
*/
  if (this.draw_y > this.y)
    this.draw_y--;
  else if (this.draw_y < this.y)
    this.draw_y++;    
}

function DrawText(x, y, text)
{
  system_font.drawText(x, y, text);
}

function pause()
{
  while (AreKeysLeft()) 
    GetKey();
  
  while (!AreKeysLeft())
    ;
}

