/*
                              @
     ___                _____| |____               _____
    /__/__              \____   ___/       /|     / ___/
  / /  /  \ __      __  ___  | |   __  _  | |  _ | |
 | |  | |\ |\ \    / / /__/  | |  /  \| | | | |_||  \__
 | |  | |/ | \ \  / / ||__   | | | /\ | | | |  _  \___ \
 | |  | |\ \  \ \/ /  |__ |  | | ||  |  | | | | |     \ |
 | |__| | | |  |  |    __||  | | | \/ | | | | | |  ___/ |
  \___\\| |/   |__|   /__/   |/   \__/|_| |/  |/  /____/
  
  
                       for sphere
                           ---
                        by fenix

*/

var mainCharacter = new Person();
var hurt = LoadSound("M_attack.wav");
var coin = LoadSound("cash.wav");
var font = GetSystemFont()
var window = LoadWindowStyle("crystalis.rws");
var characterWidth = 13;
var enemyWidth = 16;

function game(){
  CreatePerson("main", "main.rss", false);
  AttachInput("main");
  SetRenderScript("render();");
  MapEngine("start.rmp", 60);
}

function render(){
  speedPersonUp();
  fixCamera();
  drawStatusWindow();
  var personHit = checkHurt();
  if(personHit) hurtPerson(personHit);
}

function hurtPerson(person){
  var type = "";
  for(var i = 0; i < person.length; i++){
    if(person.charAt(i) != "1" || person.charAt(i) != "2" || person.charAt(i) != "3" || person.charAt(i) != "4" || person.charAt(i) != "5" || person.charAt(i) != "6" || person.charAt(i) != "7" || person.charAt(i) != "8" || person.charAt(i) != "9" || person.charAt(i) != "0"){
       type += person.charAt(i);
     }
  }
  var crap = false;
  if(type == "coin"){
    var coinType = "";
    for(var i = 0; i < person.length; i++){
      if(person.charAt(i) != "1" || person.charAt(i) != "2" || person.charAt(i) != "3" || person.charAt(i) != "4" || person.charAt(i) != "5" || person.charAt(i) != "6" || person.charAt(i) != "7" || person.charAt(i) != "8" || person.charAt(i) != "9" || person.charAt(i) != "0" && crap){
         coinType += person.charAt(i);
      }
      if(person.charAt(i) == ":") crap = true;
    }
  }
  var rad = (GetPersonY(person) - GetPersonX("main"))/(GetPersonX(person) - GetPersonX("main"));
  if(GetPersonY("main") > GetPersonY(person)){
    rad += Math.PI;
  }  
  if(rad == "NaN"){
    rad = 0;
  }
  switch(type){
    case("coin"):
      coin.play(false);
      switch(coinType){
        default:
          DestroyPerson(person);
          break;
      }
      break;
    default:
      hurt.play(false);
      hurtMove(rad);
      break;
  }
}

function hurtMove(rad){
  DetachInput();
  SetPersonScript("main", SCRIPT_COMMAND_GENERATOR, 
    "if(!counter || counter > 10) var counter = 1;" + 
    "SetPersonX('main', GetPersonX('main') - Math.cos(" + rad + ")*5);" +
    "SetPersonY('main', GetPersonY('main') - Math.sin(" + rad + ")*5);" + 
    "counter++;" + 
    "SetPersonFrame('main', 0);" + 
    "if(counter > 10) AttachInput('main');" + 
    "if(counter > 10) SetPersonScript('main', SCRIPT_COMMAND_GENERATOR, '');");
}

function xy(x, y){
  this.x = x;
  this.y = y;
}

function checkHurt(){
  var people = GetPersonList();
  var testPoint = new Array(4);
  testPoint[0] = new xy(GetPersonX("main") - 1, GetPersonY("main") - 1);
  testPoint[1] = new xy(GetPersonX("main") + 13 + 1, GetPersonY("main") - 1);
  testPoint[2] = new xy(GetPersonX("main") + 13 + 1, GetPersonY("main") + 13 + 1);
  testPoint[3] = new xy(GetPersonX("main") - 1, GetPersonY("main") + 13 + 1);
  if(
     IsPersonObstructed("main", GetPersonX("main")+0, GetPersonY("main")+0)
  || IsPersonObstructed("main", GetPersonX("main")+1, GetPersonY("main")+0) 
  || IsPersonObstructed("main", GetPersonX("main")-1, GetPersonY("main")+0) 
  || IsPersonObstructed("main", GetPersonX("main")+0, GetPersonY("main")+1) 
  || IsPersonObstructed("main", GetPersonX("main")+0, GetPersonY("main")-1)
    ){
    for(var i = 0; i < people.length; i++){
      for(var j = 0; j < 4; j++){
        if(IsPersonObstructed(people[i], testPoint[j].x, testPoint[j].y))
          if(people[i] != "main") 
            return people[i];
      }
    }
  }
}

function speedPersonUp(){
  if(!IsPersonObstructed("main", GetPersonX("main"), GetPersonY("main"))){
    if(IsKeyPressed(KEY_LEFT)){
      SetPersonX("main", GetPersonX("main") - 1);
    }
    if(IsKeyPressed(KEY_RIGHT)){
      SetPersonX("main", GetPersonX("main") + 1);
    }
    if(IsKeyPressed(KEY_UP)){
      SetPersonY("main", GetPersonY("main") - 1);
    }
    if(IsKeyPressed(KEY_DOWN)){
      SetPersonY("main", GetPersonY("main") + 1);
    }
  }
}

function fixCamera(){
  var x = GetCameraX() - GetPersonX("main") + GetScreenWidth()/2;
  var y = GetCameraY() - GetPersonY("main") + GetScreenHeight()/2
  if(x < 60) SetCameraX(GetCameraX() + .5);
  if(x < 30) SetCameraX(GetCameraX() + 1);
  if(x > GetScreenWidth() - 60) SetCameraX(GetCameraX() - .5);
  if(x > GetScreenWidth() - 30) SetCameraX(GetCameraX() - 1);
  if(y < 100) SetCameraY(GetCameraY() + 1);
  if(y < 120) SetCameraY(GetCameraY() + .5);
  if(y > 180) SetCameraY(GetCameraY() - 1);
  if(y > 200) SetCameraY(GetCameraY() - 1);
}

function drawStatusWindow(){
  window.drawWindow(8, GetScreenHeight()*2/3 + 8, GetScreenWidth() - 16, GetScreenHeight()*1/3 - 16);
  var y = GetCameraY() - GetPersonY("main") + GetScreenHeight()/2;
  font.drawText(20,200, y);
}

function walkRandom(name){
  var random = Math.floor(Math.random()*5);
  var action;
  switch(random){
    case(0): action = COMMAND_WAIT; break;
    case(1): action = COMMAND_MOVE_NORTH; break;
    case(2): action = COMMAND_MOVE_EAST; break;
    case(3): action = COMMAND_MOVE_SOUTH; break;
    case(4): action = COMMAND_MOVE_WEST; break;
  }
  switch(action){
    case(COMMAND_WAIT):
      for(var i = 0; i < 16; i++){
        QueuePersonCommand(name, action, false);
      }
      break;
    case(COMMAND_MOVE_NORTH):
      QueuePersonCommand(name, COMMAND_FACE_NORTH, true);
      for(var i = 0; i < 16; i++){
        QueuePersonCommand(name, action, false);
      }
      break;
    case(COMMAND_MOVE_EAST):
      QueuePersonCommand(name, COMMAND_FACE_EAST, true);
      for(var i = 0; i < 16; i++){
        QueuePersonCommand(name, action, false);
      }
      break;
    case(COMMAND_MOVE_SOUTH):
      QueuePersonCommand(name, COMMAND_FACE_SOUTH, true);
      for(var i = 0; i < 16; i++){
        QueuePersonCommand(name, action, false);
      }
      break;
    case(COMMAND_MOVE_WEST):
      QueuePersonCommand(name, COMMAND_FACE_WEST, true);
      for(var i = 0; i < 16; i++){
        QueuePersonCommand(name, action, false);
      }
      break;
  }
}

function Person(){
  this.name = "_";
}