// include system scripts that we need
EvaluateSystemScript("screen.js");  // includes FadeIn and FadeOut
EvaluateSystemScript("menu.js");    // the Menu object
EvaluateSystemScript("audio.js");
EvaluateSystemScript("input.js");

EvaluateScript("maps.js");
EvaluateScript("cave.js");
EvaluateScript("menu.js");


// global variables
var Arrow        = LoadImage("arrow.png");
var Font         = LoadFont("main.rfn");
var GradientFont = LoadFont("main_gradient.rfn");
var WindowStyle  = LoadWindowStyle("main.rws");


var Player = new Object;


function game()
{
  Intro();
  MainMenu();
}


// displays three images in succession
function Intro()
{
  IntroImage("WARNING.PCX");
  IntroImage("INTRO.PCX");
  IntroImage("INTRO2.PCX");
}


// fades an image in, waits for a keypress, and fades out
function IntroImage(name)
{
  var image = LoadImage(name);
  image.blit(0, 0);
  FadeIn(100);
  GetKey();
  FadeOut(100);
}


// the main menu
function MainMenu()
{
  // create the menu object
  var menu = new Menu();
  menu.arrow           = Arrow;
  menu.font            = GradientFont;
  menu.window_style    = WindowStyle;
  menu.escape_function = Exit;

  // add the commands to it
  menu.addItem("New Game",    NewGame);
  menu.addItem("Resume Game", ResumeGame);
  menu.addItem("Quit",        Exit);

  while (true) {
  
    ClearScreen();  // we want a clear backbuffer behind the menu
    menu.execute(16, 16, 128, 25);

  }
}


function NewGame()
{
  GetName();
  IntroImage("START1.PCX");
  IntroImage("START2.PCX");
  PlaySound("NEWGAME.WAV");
  
  // start in the main map
  CreatePerson("main character", "main_character.rss", false);
  AttachInput("main character");
  AttachCamera("main character");
  
  BindKey(KEY_ESCAPE, "GameMenu()", "");
    
  MapEngine("main_map.rmp", 60);  
}


function GetName()
{
  var prompt = "Enter player's name: ";
  Font.drawText(8, 8, prompt);
  Player.name = GetString(8 + Font.getStringWidth(prompt), 8, GradientFont);
}


function ResumeGame()
{
}


function Configure()
{
}
