var camera = new Object();
  camera.x = 0;
  camera.y = 0;
  camera.width = GetScreenWidth();
  camera.height = GetScreenHeight();
  camera.reset = function reset(){ camera.x = 0; camera.y = 0; }
  
var file = OpenFile("map.dat");
var mapWidth = 30, mapHeight = camera.height/16;
var map = new Array(mapWidth)
var startX = 0;
var startY = 0;

for(var i = 0; i < mapWidth; i++){
  map[i] = new Array(mapHeight);
}
for(var i = 0; i < mapWidth; i++){
  for(var j = 0; j < mapHeight; j++){
    map[i][j] = file.read(i + "," + j, 0);
    if(map[i][j] == 2){
      startX = i*16;
      startY = i*16;
    }
  }
}
var arrayOfImages = new Array()
arrayOfImages[0] = LoadImage("passible.png");
arrayOfImages[1] = LoadImage("impassible.png");
arrayOfImages[1].impassible = true;
arrayOfImages[2] = LoadImage("test.png");
arrayOfImages[3] = LoadImage("test2.png");

var player = new Object();
  player.image = 2;
  player.timeCounter = GetTime();
  player.imageDelay = 0;
  player.startImage = 2;
  player.endImage = 3;
  player.minJumpHeight = 16;
  player.maxJumpHeight = 64;
  player.width = arrayOfImages[player.image].width;
  player.height = arrayOfImages[player.image].height;
  player.xAccel = .5;
  player.maxSpeed = 2;
  player.xDecel = .2;
  player.yAccel = 4;
  player.yDecel = .1;
  player.xSpeed = 0;
  player.ySpeed = 0;
  player.canJump = false;
  player.y = startY;
  player.x = startX;
  player.blit = 
    function blit(){
      arrayOfImages[player.image].blit(player.x - camera.x, player.y - camera.y);
    }
  player.update = 
    function update(){
      player.imageDelay = 500/Math.abs(player.xSpeed);
      if(player.timeCounter + player.imageDelay < GetTime()){
        player.image++;
        player.timeCounter = GetTime();
        if(player.image > player.endImage){
          player.image = player.startImage;
        }
      }
      if(!IsObstructed(player.x+1, player.y + player.ySpeed, player.width-1, player.height)){
        player.ySpeed += player.yDecel;
      }
      if(IsObstructed(player.x+1, player.y + player.ySpeed, player.width-1, player.height, "bottom")){
        player.ySpeed = 0;
        player.canJump = true;
      }
      if(IsObstructed(player.x, player.y + player.ySpeed, player.width, player.height, "top")){
        player.ySpeed = 0;
      }
      if(player.xSpeed){
        player.x += player.xSpeed;
      }
      if(player.ySpeed){
        player.y += player.ySpeed;
        player.canJump = false;
      }
      if(IsKeyPressed(KEY_RIGHT)){
        player.xSpeed += player.xAccel;
        if(Math.abs(player.xSpeed) > player.maxSpeed){
          player.xSpeed = player.maxSpeed;
        }
        if(IsObstructed(player.x, player.y+1, player.width, player.height-2, "right")){
          player.xSpeed = 0;
        }
      }
      if(IsKeyPressed(KEY_LEFT)){
        player.xSpeed -= player.xAccel;
        if(Math.abs(player.xSpeed) > player.maxSpeed){
          player.xSpeed = -player.maxSpeed;
        }
        if(IsObstructed(player.x, player.y+1, player.width, player.height-1, "left")){
          player.xSpeed = 0;
        }
      }
      if(!IsKeyPressed(KEY_RIGHT) && !IsKeyPressed(KEY_LEFT)){
        if(player.xSpeed > 0){
          var crap = true;
        }
        if(player.xSpeed < 0){
          var crap = false;
        }
        if(player.xSpeed > 0){
          player.xSpeed -= player.xDecel;
        }
        if(player.xSpeed < 0){
          player.xSpeed += player.xDecel;
        }
        if(player.xSpeed > 0 && crap == false){
          player.xSpeed = 0;
        }
        if(player.xSpeed < 0 && crap == true){
          player.xSpeed = 0;
        }
        delete crap;
      }
      if(IsKeyPressed(KEY_SPACE) && player.canJump){
        player.ySpeed = -player.yAccel;
        player.canJump = false;
      }
    }
function game(){
  edit();
  while(IsKeyPressed(KEY_ESCAPE)){}
  play();
}

function edit(){
  camera.reset();
  var xHover = 0;
  var yHover = 0;
  var singleClick = false;
  while(!IsKeyPressed(KEY_ESCAPE)){
    for(var i = 0; i < mapWidth; i++){
      for(var j = 0; j < mapHeight; j++){
        if(i*16 - camera.x > -16 && i*16 - camera.x < camera.width) arrayOfImages[map[i][j]].blit(i*16 - camera.x, j*16 - camera.y);
      }
    }

    if(IsKeyPressed(KEY_LEFT)) camera.x--;
    if(IsKeyPressed(KEY_RIGHT)) camera.x++;

    xHover = Math.floor((GetMouseX() + camera.x)/16);
    yHover = Math.floor((GetMouseY() + camera.y)/16);
    
    if(singleClick && (!IsMouseButtonPressed(MOUSE_LEFT) && !IsMouseButtonPressed(MOUSE_RIGHT))){
      singleClick = false;
    }
    if(IsMouseButtonPressed(MOUSE_LEFT) && !singleClick){
      if(xHover >= 0 && xHover < mapWidth){
        if(yHover >= 0 && yHover < mapHeight){
          map[xHover][yHover]++;
        }
      }
      singleClick = true;
      for(var i = 0; i < mapWidth; i++){
        for(var j = 0; j < mapHeight; j++){
          if(map[xHover][yHover] > arrayOfImages.length-1){
            map[xHover][yHover] = 0;
          }
          if(map[xHover][yHover] < 0){
            map[xHover][yHover] = arrayOfImages.length-1;
          }
        }
      }
    }
    if(IsMouseButtonPressed(MOUSE_RIGHT) && !singleClick){
      if(xHover >= 0 && xHover < mapWidth){
        if(yHover >= 0 && yHover < mapHeight){
          map[xHover][yHover]--;
        }
      }
      singleClick = true;
      for(var i = 0; i < mapWidth; i++){
        for(var j = 0; j < mapHeight; j++){
          if(map[xHover][yHover] > arrayOfImages.length-1){
            map[xHover][yHover] = 0;
          }
          if(map[xHover][yHover] < 0){
            map[xHover][yHover] = arrayOfImages.length-1;
          }
        }
      }
    }
    Rectangle(xHover*16 - camera.x, yHover*16 - camera.y, 16, 16, CreateColor(255,255,0,128));
    DrawMouse(GetMouseX(),GetMouseY());
    FlipScreen();
  }
  for(var i = 0; i < mapWidth; i++){
    for(var j = 0; j < mapHeight; j++){
      file.write(i + "," + j, map[i][j]);
    }
  }
}

function play(){
  camera.reset();
  while(!IsKeyPressed(KEY_ESCAPE)){
    for(var i = 0; i < mapWidth; i++){
      for(var j = 0; j < mapHeight; j++){
        if(i*16 - camera.x > -16 && i*16 - camera.x < camera.width) arrayOfImages[map[i][j]].blit(i*16 - camera.x, j*16 - camera.y);
      }
    }
    player.blit();
    player.update();
/*
    if(IsKeyPressed(KEY_UP)) player.y--;
    if(IsKeyPressed(KEY_DOWN)) player.y++;
    if(IsKeyPressed(KEY_LEFT)) player.x--;
    if(IsKeyPressed(KEY_RIGHT)) player.x++;
*/
    camera.x = player.x - camera.width/2;
    camera.y = player.y - camera.height/2;
    FlipScreen();
  }
}

function IsObstructed(x, y, width, height, direction){
  if(!direction) direction = "all";
  var testPoints = new Array();
  if(direction == "left"){
    testPoints[0] = new Object();
    testPoints[0].x = Math.floor((x)/16);
    testPoints[0].y = Math.floor((y)/16);
    testPoints[1] = new Object();
    testPoints[1].x = Math.floor((x)/16);
    testPoints[1].y = Math.floor((y + width/2)/16);
    testPoints[2] = new Object();
    testPoints[2].x = Math.floor((x)/16);
    testPoints[2].y = Math.floor((y + width)/16);
  }
  if(direction == "right"){
    testPoints[0] = new Object();
    testPoints[0].x = Math.floor((x + width)/16);
    testPoints[0].y = Math.floor((y)/16);
    testPoints[1] = new Object();
    testPoints[1].x = Math.floor((x + width)/16);
    testPoints[1].y = Math.floor((y + width/2)/16);
    testPoints[2] = new Object();
    testPoints[2].x = Math.floor((x + width)/16);
    testPoints[2].y = Math.floor((y + width)/16);
  }
  if(direction == "bottom"){
    testPoints[0] = new Object();
    testPoints[0].x = Math.floor((x)/16);
    testPoints[0].y = Math.floor((y + height)/16);
    testPoints[1] = new Object();
    testPoints[1].x = Math.floor((x + width)/16);
    testPoints[1].y = Math.floor((y + height)/16);
  }
  if(direction == "top"){
    testPoints[0] = new Object();
    testPoints[0].x = Math.floor((x)/16);
    testPoints[0].y = Math.floor((y)/16);
    testPoints[1] = new Object();
    testPoints[1].x = Math.floor((x + width)/16);
    testPoints[1].y = Math.floor((y)/16);
  }
  if(direction == "all"){
    testPoints[0] = new Object();
    testPoints[0].x = Math.floor((x)/16);
    testPoints[0].y = Math.floor((y)/16);
    testPoints[1] = new Object();
    testPoints[1].x = Math.floor((x)/16);
    testPoints[1].y = Math.floor((y + width/2)/16);
    testPoints[2] = new Object();
    testPoints[2].x = Math.floor((x)/16);
    testPoints[2].y = Math.floor((y + width)/16);
    testPoints[3] = new Object();
    testPoints[3].x = Math.floor((x + width)/16);
    testPoints[3].y = Math.floor((y)/16);
    testPoints[4] = new Object();
    testPoints[4].x = Math.floor((x + width)/16);
    testPoints[4].y = Math.floor((y + width/2)/16);
    testPoints[5] = new Object();
    testPoints[5].x = Math.floor((x + width)/16);
    testPoints[5].y = Math.floor((y + width)/16);
  }
  var isObstructed = false;
  for(var i = 0; i < testPoints.length; i++){
    GetSystemFont().drawText(0, 10 + i*GetSystemFont().getHeight(), testPoints[i].x + "," + testPoints[i].y);
    if(map[testPoints[i].x]){
      if(map[testPoints[i].x][testPoints[i].y]){
        if(arrayOfImages[map[testPoints[i].x][testPoints[i].y]].impassible){
          isObstructed = true;
        }
      }
    }
    else isObstructed = true;
  }
  return isObstructed;
}

function pointOverRectangle(x, y, testX, testY, testWidth, testHeight){
  if(x > testX && x < testX + testWidth){
    if(y > testY && y < testY + testHeight){
      return true;
    }
  }
  return false;
}

function DrawMouse(x, y){
  Triangle(x, y, x, y+10, x+6, y+8, CreateColor(0,0,255));
}

function getKeyStroke(){
  var str = "";
  while (AreKeysLeft()) {
    var key = GetKey();
    str += GetKeyString(key, IsKeyPressed(KEY_SHIFT));
  } // end while (keys left)
  if(str != "") return str;
  else return "";
}

