EvaluateScript("system.js");
EvaluateScript("party.js");

function InitMenuSystem()
{
}

///////////////////////////////////////////////////////////////////////////

function vergeWindow(x, y, x2, y2)
{
  // figure out "system" windowstyle's width
  var system_window_width = 5;
  var system_window_height = 4;
  var verge_offset = 16; // I dunno why vecna did this though?
  var window_width = x2 - x - (system_window_width * 2);
  var window_height = y2 - y - (system_window_height * 2);
  
  system_window.drawWindow(x-verge_offset+system_window_width, 
                           y-verge_offset+system_window_height, 
                           window_width, window_height);
}

///////////////////////////////////////////////////////////////////////////

function vergeText(x, y, text)
{
  var verge_offset = 16; // I dunno why vecna did this though?
  system_font_small.drawText(x - verge_offset, y - verge_offset, text);
}

///////////////////////////////////////////////////////////////////////////

function vergePointer(x, y)
{
  var verge_offset = 16;
  system_pointer.blit(x - verge_offset, y - verge_offset);
}

///////////////////////////////////////////////////////////////////////////

function drawPartyStats()
{
  vergeWindow(210, 20, 330, 32+(PartyIndex.length*30));
  for (var i=0; i<PartyIndex.length; i++)
    with (Char[PartyIndex[i]]) {
    
      // character name
      vergeText(217, 27+(i*30), name);
 
      // status display: display level if alive, otherwise dead
      if (status == 0) {
        vergeText(290, 27+(i*30), "LV");
        var lv_string_width = system_font_small.getStringWidth(lv);
        vergeText(322-lv_string_width, 27+(i*30), lv);
      } else {
        vergeText(290, 27+(i*30), "DEAD");
      }
      
      // HP display
      var curhp_string_width = system_font_small.getStringWidth(curhp);
      var maxhp_string_width = system_font_small.getStringWidth(maxhp);
      vergeText(230, 37+(i*30), "HP");
      vergeText(278-curhp_string_width, 37+(i*30), curhp);
      vergeText(278, 37+(i*30), "/");
      vergeText(310-maxhp_string_width, 37+(i*30), maxhp);
      
      
      // MP display
      var curmp_string_width = system_font_small.getStringWidth(curmp);
      var maxmp_string_width = system_font_small.getStringWidth(maxmp);
      vergeText(230, 47+(i*30), "MP");
      vergeText(278-curhp_string_width, 47+(i*30), curmp);
      vergeText(278, 47+(i*30), "/");
      vergeText(310-maxhp_string_width, 47+(i*30), maxmp);
    }
}

///////////////////////////////////////////////////////////////////////////

function drawMainMenu(current_selection)
{
  // options
  vergeWindow(20, 20, 120, 95);
  vergeText(40, 27, "Item");
  vergeText(40, 37, "Equip");
  vergeText(40, 47, "Magic");
  vergeText(40, 57, "Status");
  vergeText(40, 67, "Order");
  vergeText(40, 77, "Tactic");
  
  // gp
  vergeWindow(210, 185, 330, 205);
  vergeText(308, 191, "GP");
  var gp_string_width = system_font_small.getStringWidth(Gold);
  vergeText(300-gp_string_width, 191, Gold);
  
  // pointer
  vergePointer(20, 25+(current_selection*10));
}

///////////////////////////////////////////////////////////////////////////

function whoIs(current_selection)
{
  if (PartyIndex.length == 1) return 0;
  
  var whois_cursor = 0;
  var loopStatus = 0;

  // eat the keys
  while (AreKeysLeft()) GetKey();
  
  // 0 = running, -1 = cancelled, 1 = success
  while (loopStatus == 0) {
  
    RenderMap();
    drawMainMenu(current_selection);
    drawPartyStats();
    vergeWindow(20, 110, 120, 122+(PartyIndex.length*10));
    for (var i=0; i<PartyIndex.length; i++) {
      vergeText(40, 117+(i*10), Char[PartyIndex[i]].name);
    }
    vergePointer(20, 115+(whois_cursor*10));
    FlipScreen();
    
    while (AreKeysLeft()) {
      var key = GetKey();
      
      switch(key) {
        case KEY_UP: whois_cursor++;  break;
        case KEY_DOWN: whois_cursor--; break;
        case KEY_ENTER: loopStatus++; break;
        case KEY_ALT: loopStatus--; break;
      }
      
      if (whois_cursor < 0) whois_cursor = PartyIndex.length - 1;
      if (whois_cursor == PartyIndex.length) whois_cursor = 0;
      if (loopStatus != 0) while (AreKeysLeft()) GetKey();
    }
  }
  
  // gather the results
  if (loopStatus > 0) 
    return whois_cursor;
  else
    return -1;
}

///////////////////////////////////////////////////////////////////////////

function reOrder(current_selection)
{
  var done = false;
  var selected_cursor = -1;
  var whois_cursor = 0;
  var flash = 0;
  
  while (done != true) {
    RenderMap();
    drawMainMenu(current_selection);
    drawPartyStats();
    
    // character names here ;)
    vergeWindow(20, 110, 120, 123+(PartyIndex.length*10));
    for (var i=0; i<PartyIndex.length; i++)
      vergeText(40, 117+(i*10), Char[PartyIndex[i]].name);
      
    vergePointer(20, 115+(whois_cursor*10));
    if (selected_cursor >= 0 && flash%2)
      vergePointer(20, 115+(selected_cursor*10));
    flash++;
    FlipScreen();
    
    while (AreKeysLeft()) {
      var key = GetKey();
      switch(key) {
        case KEY_UP:   
          whois_cursor--; 
          if (whois_cursor == selected_cursor) whois_cursor--;
          if (whois_cursor < 0) whois_cursor = PartyIndex.length - 1;
          if (whois_cursor == selected_cursor) whois_cursor--;
          break;
          
        case KEY_DOWN: 
          whois_cursor++; 
          if (whois_cursor == selected_cursor) whois_cursor++;
          if (whois_cursor >= PartyIndex.length) whois_cursor = 0;
          if (whois_cursor == selected_cursor) whois_cursor++;
          break;
        
        case KEY_ALT:
          if (selected_cursor < 0)
            done = true;
          else
            whois_cursor = selected_cursor;
            selected_cursor = -1;
          break;
          
        case KEY_ENTER: 
          if (selected_cursor < 0) {
            selected_cursor = whois_cursor;
            whois_cursor++;
            if (whois_cursor >= PartyIndex.length) whois_cursor = 0;
          } else {
            //swap characters around
            return;
          }
          break;
      }
      
      //if (whois_cursor < 0) whois_cursor = PartyIndex.length - 1;
      //if (whois_cursor >= PartyIndex.length) whois_cursor = 0;
    }
  }
}

///////////////////////////////////////////////////////////////////////////

function statusScreen(selected_character)
{
  var done = false;
  var current_char = PartyIndex[selected_character];
  
  while (done != true)
    with (Char[current_char])
    {
      RenderMap();
    
      // portrait
      portrait.blit(20-16, 20-16);
    
      // namebox
      vergeWindow(120, 20, 220, 40);
      var name_string_width = system_font_small.getStringWidth(name);
      vergeText(170-(name_string_width/2), 26, name);
    
      // stats windows :)
      vergeWindow(230, 20, 330, 40);
      vergeText(256, 26, "STATUS");
      vergeWindow(120, 45, 220, 116);
    
      // HP
      vergeText(127, 51, "HP");
      var curhp_string_width = system_font_small.getStringWidth(curhp);
      var maxhp_string_width = system_font_small.getStringWidth(maxhp);
      vergeText(183 - curhp_string_width, 51, curhp);
      vergeText(183, 51, "/");
      vergeText(215 - maxhp_string_width, 51, maxhp);
    
      // MP
      vergeText(127, 61, "MP");
      var curmp_string_width = system_font_small.getStringWidth(curmp);
      var maxmp_string_width = system_font_small.getStringWidth(maxmp);
      vergeText(183 - curmp_string_width, 61, curmp);
      vergeText(183, 61, "/");
      vergeText(215 - maxmp_string_width, 61, maxmp);
    
      // status
      var current_status = "";
      switch (status)
      {
        case 0: current_status = "GOOD"; break;
        case 1: current_status = "DEAD"; break;
      }
      vergeText(127, 100, current_status);
      
      // level and experience window
      vergeWindow(230, 45, 330, 116);
      vergeText(237, 51, "LV");
      vergeText(237, 61, "EXP");
      vergeText(237, 71, "NEXT");
      var lv_string_width = system_font_small.getStringWidth(lv);
      var exp_string_width = system_font_small.getStringWidth(exp);
      var next_string_width = system_font_small.getStringWidth(nxt-exp);
      vergeText(320-lv_string_width, 51, lv);
      vergeText(320-exp_string_width, 61, exp);
      vergeText(320-next_string_width, 71, nxt-exp);
    
      // stats!
      vergeWindow(180, 120, 330, 200);
      vergeText(187, 129, "STR");
      vergeText(187, 139, "END");
      vergeText(187, 149, "HIT");
      vergeText(187, 159, "DOD");
      vergeText(187, 169, "MAG");
      vergeText(187, 179, "MGR");
      var str_string_width = system_font_small.getStringWidth(str);
      var end_string_width = system_font_small.getStringWidth(end);
      var hit_string_width = system_font_small.getStringWidth(hit);
      var dod_string_width = system_font_small.getStringWidth(dod);
      var mag_string_width = system_font_small.getStringWidth(mag);
      var mgr_string_width = system_font_small.getStringWidth(mgr);
      vergeText(250-str_string_width, 129, str);
      vergeText(250-end_string_width, 139, end);
      vergeText(250-hit_string_width, 149, hit);
      vergeText(250-dod_string_width, 159, dod);
      vergeText(250-mag_string_width, 169, mag);
      vergeText(250-mgr_string_width, 179, mgr);

      // stats! part 2 rea, mbl, fer, atk, def
      vergeText(260, 129, "REA");
      vergeText(260, 139, "MBL");
      vergeText(260, 149, "FER");
      vergeText(260, 169, "ATK");
      vergeText(260, 179, "DEF");
      var rea_string_width = system_font_small.getStringWidth(rea);
      var mbl_string_width = system_font_small.getStringWidth(mbl);
      var fer_string_width = system_font_small.getStringWidth(fer);
      var atk_string_width = system_font_small.getStringWidth(atk);
      var def_string_width = system_font_small.getStringWidth(def);
      vergeText(320-rea_string_width, 129, rea);
      vergeText(320-mbl_string_width, 139, mbl);
      vergeText(320-fer_string_width, 149, fer);
      vergeText(320-atk_string_width, 169, atk);
      vergeText(320-def_string_width, 179, def);
      
      // equipment box
      vergeWindow(20, 120, 170, 200);
    
      FlipScreen();
    
      while (AreKeysLeft()) {
        var key = GetKey();
      
        switch(key) {
          case KEY_LEFT:
            selected_character--;
            if (selected_character < 0) selected_character = PartyIndex.length - 1;
            current_char = PartyIndex[selected_character];
            break;
            
          case KEY_RIGHT:
            selected_character++;
            if (selected_character >= PartyIndex.length) selected_character = 0;
            current_char = PartyIndex[selected_character];            
            break;
          
          case KEY_ALT: 
          case KEY_ENTER:
          case KEY_SPACE:
            done = true; 
            break;
        }
      }
    }
}

function mainMenu()
{
  var loopStatus = 0;
  var selection_cursor = 0;
  var selection;
  var done = false;

  while (done != true) {
    loopStatus = 0;
  
    while (loopStatus == 0) {
      RenderMap();
      drawMainMenu(selection_cursor);
      drawPartyStats();
  
      FlipScreen();
    
      while (AreKeysLeft()) {
        var key = GetKey();
        switch (key) {
          case KEY_UP:   selection_cursor--; break;
          case KEY_DOWN: selection_cursor++; break;
          case KEY_ALT:   loopStatus--; break;
          case KEY_ENTER: loopStatus++; break;
        }
      
        if (selection_cursor < 0) selection_cursor = 5;
        if (selection_cursor > 5) selection_cursor = 0;
      }
    }
  
    // do post-results here
    if (loopStatus < 0) {
      done = true;
      break;
    }
  
    switch (selection_cursor) {
      case 3: statusScreen(whoIs(selection_cursor)); break;
      case 4: reOrder(selection_cursor); break;
    }
  
  }
}

function drawItemMenu(selected_character)
{
}

function itemMenu(selected_character)
{
}

function audioVolume()
{
  var done = false;
  var red = CreateColor(255, 0, 0, 255);
  var volume = 0;
  
  while (done != true)
  {
    RenderMap();
    vergeWindow(96, 96, 256, 136);
    DrawRectangle(110, 98, 0, 118, red);
  }
}